#include <bits/stdc++.h>

using namespace std;

int main(void)
{
    int brojTakmicara;
    long int prihvacene, neprihvacene;
    long int nizP[3000];
    long int nizN[3000];
    long int razlika[3000];
    long int razlika2[3000];
    int resenje[brojTakmicara];
    long int x, n, n1;
    cin >> brojTakmicara;
    for(int a=0; a<brojTakmicara; ++a)
    {
        cin >> prihvacene;
        cin >> neprihvacene;

        for(int i=0; i<prihvacene; ++i)
        {
            cin >> nizP[i];
        }

        for(int i=0; i<neprihvacene; ++i)
        {
            cin >> nizN[i];
        }

        sort(nizP, nizP + prihvacene);
        sort(nizN, nizN + neprihvacene);

        for(int i=0; i<prihvacene-1; ++i)
        {
            razlika[i]=nizP[i+1]-nizP[i];
        }

        sort(razlika, razlika+prihvacene-1);

        x = razlika[0];
        n = 0;

        for(int i=1; i<prihvacene-1; ++i)
        {
            if(razlika[i]%x==0)
                n++;
        }
        for(int i=0; i<neprihvacene-1; ++i)
        {
            razlika2[i]=nizN[i+1]-nizN[i];
        }

        sort(razlika2, razlika2+neprihvacene-1);

        n1=0;
        for(int i=0; i<neprihvacene-1; ++i)
        {
            if(razlika2[i]%x==0)
                n1++;
        }
        if(n1<neprihvacene-1 && n==prihvacene-2)
            resenje[a] = 1;
        else
            resenje[a] = 0;
    }
    for(int a=0; a<brojTakmicara; ++a)
    {
        cout << resenje[a] << "\n";
    }

    return 0;
}